                                        ;ELICA 1.3 - Umberto Barone

;;;Questo lisp  stato realizzato da Umberto Barone;
;;; gratis e vieto a chiunque di utilizzarlo a fini di lucro,
;;;pu essere liberamente utilizzato, modificato, distribuito;
;;;prego solo di lasciare la firma come riconoscimento dei diritti 
;;;intelettuali

;;;;name: elica_1.3
;;;command: elica
;;;input: centro raggio passo altezza
;;;output: draw

;;;il file elica.dcl va collocato nella directory Support di acad
;;;la risoluzione  il numero di segmenti utilizzati x ogni 360

;;;Per errori, aggiornamenti, personalizzazioni contattami qui
;;;u.barone@tiscali.it
;;;htpp://web.tiscalinet.it/umberweb

 ;____________________________MAIN PROGRAM__________________________________________
(defun c:elica  (/ dcl_id r h p xc yc zc center select p_el h1 h1* betar betar* rcb rsb 2d
                 old_error trappola val why lis var_old var_new lista)
  (if (findfile "elica.dcl")            ;cerca elica.dcl
    (progn
      (setq dcl_id (load_dialog "elica.dcl")) ;carica elica.DCL
      (if (not (new_dialog "elica" dcl_id)) ;altrimenti esci
        (exit))
      (mode_tile "eb_r" 2)              ;set focus edit_box raggio
      (action_tile "accept"             ;OK ACTION
                   (strcat
                     "(progn (setq r(atof (get_tile \"eb_r\")))" ;leggi raggio
                     "(setq h (atof  (get_tile \"eb_h\")))" ;altezza
                     "(setq p (atof (get_tile \"eb_p\")))" ;passo
                     "(setq nvett360 (atof (get_tile \"nvett360\")))" ;risoluzione
                     "(setq 2d (atof (get_tile \"rb_2d\")))" ;2d o meno
                     "(setq select (atof (get_tile \"select\")))"
                     "(cond ((= select 0)(setq xc (atof(get_tile \"eb_xc\")))"
                     "(setq yc  (atof(get_tile \"eb_yc\")))" ;coo centro se select=0
                     "(setq zc  (atof(get_tile \"eb_zc\")))))" "(done_dialog 1))"))
      (action_tile "cancel" "(done_dialog 0)") ;CANCEL ACTION
      (action_tile "select"
                   "(setq select $value)(update1)" ;controllo edit box coo centro
                   )
      (action_tile "nvett360slide"      ;*if user moves slider
                   "(slide1 $value $reason)") ;*pass arguments to slider_action
      (action_tile "nvett360"           ;*is user enters slot length
                   "(ebox1 $value $reason)") ;*pass arguments to ebox_action
      (defun slide1  (val why)          ;*define function
        (if (or (= why 2) (= why 1))    ;*check values
          (set_tile "nvett360" val)))   ;*update edit box
      (defun ebox1  (val why)           ;*define function
        (if (or (= why 2) (= why 1))    ;*check values
          (set_tile "nvett360slide" val)))
      (action_tile "reset"              ;RESET ACTION
                   (strcat
                     "(progn (set_tile \"eb_r\" \" \")" ;update
                     "(set_tile \"eb_h\" \" \")(set_tile \"eb_p\" \"\")"
                     "(set_tile \"eb_xc\" \"0\")(set_tile \"eb_yc\" \"0\")"
                     "(set_tile \"eb_zc\" \"0\"))"
                     "(set_tile \"nvett360\" \"72\")(set_tile \"nvett360slide\" \"72\")"))
      (action_tile "info" "(info)")     ;INFO ACTION
      (if (= (start_dialog) 1)          ;OK ACTION
        (progn (setq old_error *error*) ;salva *error*
               (setq *error* trappola)  ;ridefinisci *error*
               (cond ((= select 0) (setq center (list xc yc zc)))
                                        ;set centro se select=0
                     ((= select 1)    ;altrimenti chiedi x centro
                      (setq center (getpoint "\nSeleziona  centro: ")))) ;end cond
               (command "_ucs" "_s" "old_ucs") ;salva ucs
               (command "_ucs" "_n" center) ;nuovo ucs
               (setq h1*    (/ p nvett360) ;h1* incremento su y/z
                     h1     0           ;parti da 0 (y/z)
                     con    t           ;condizione di uscita
                     betar* (gradrad (/ 360 nvett360))
                                        ;angolo [rad] x ogni segmento 0.087266462
                     betar  0           ;parti da 0
                     lista  nil)        ;lista punti vuota
               (set_var)                ;SALVA SYSTEM VAR
               (cond ((= 2d 1) ;________________________DRAW2D	    
                      (while con
                        (setq rcb  (* (cos betar) r) ;raggio*coseno(beta) ascissa
                              p_el (list rcb h1)) ;crea punto
                        (setq betar (+ betar betar*) ;incrementa beta di beta*
                              h1    (+ h1* h1) ;h1 di h1*
                              lista (cons p_el lista)) ;aggiungi punto in coda
                        (if (>= h1 h)
                          (setq con nil)) ;esci se h1=altezza
                        )
                      (setq lista (reverse lista))
                      (command "_pline" (foreach p lista (command p)))) ;disegna
                     ((= 2d 0) ;_____________________________DRAW3D
                      (while con        ;ciclo
                        (setq rcb  (* (cos betar) r) ;raggio*coseno(beta) ascissa
                              rsb  (* (sin betar) r) ;raggio*seno(beta) ordinata
                              p_el (list rcb rsb h1))
                        (setq betar (+ betar betar*)
                              h1    (+ h1* h1)
                              lista (cons p_el lista))
                        (if (> h1 h)
                          (setq con nil)))
                      (setq lista (reverse lista))
                      (command "_3dpoly" (foreach p lista (command p))) ;disegno
                      ))                ;end cond
               (reset_var)              ;RESETVAR
               )                        ;end progn
        )                               ;end if ok action
      (unload_dialog dcl_id)))          ;end if findfile
  (princ))                              ;end defun c:
 ;______________________________________________________________________
(prompt " Digita  elica  per eseguire")

 ;__________________________________UPDATE1 (controllo coo centro edit box)__________________
(defun update1  ()
  (cond ((= select "0")
         (mode_tile "eb_xc" 0)          ;enable
         (mode_tile "eb_yc" 0)
         (mode_tile "eb_zc" 0))
        ((= select "1")
         (mode_tile "eb_xc" 1)          ;disable
         (mode_tile "eb_yc" 1)
         (mode_tile "eb_zc" 1)))        ;end cond
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;TRAPPOLA__________________________________________--

(defun trappola  (errmsg)
  (reset_var)                           
  (princ (strcat "\nError:" errmsg))
  (alert "\nResetting System Variables ") ;inform user
  (setq *error* old_error)              ;restore *error*
  (princ))

;;GRADTORAD
(defun gradrad (alfa) (/ (* alfa pi) 180.0))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;SETVAR;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun set_var  ()
  (setq lis '("CMDECHO" "OSMODE")) ;lista system var da salvare
  (setq var_old (mapcar 'getvar lis))   ;lista valori originali system var
  (setq var_new (list 0 0)) ;lista valori
  (setq cont 0)                         ;contatore a 0
  (repeat (length lis)
    (setvar (nth cont lis) (nth cont var_new))
    (setq cont (1+ cont)))
  (princ))

;;*******************************RESETVAR***********************

(defun reset_var  ()
  (setq *error* old_error)              ;restore *error*
  (setq cont 0)                         ;contatore a 0
  (repeat (length lis)
    (setvar (nth cont lis) (nth cont var_old)) ;reset var
    (setq cont (1+ cont)))
  (command "_ucs" "_r" "old_ucs")       ;restore ucs
  (command "_ucs" "_d" "old_ucs")       ; delete ucs
  (princ))

 ;_______________________________info dialog_______________________________________
(defun info  (/ dcl_id1)
  (setq dcl_id1 (load_dialog "elica.dcl")) ;carica DCL
  (if (not (new_dialog "info" dcl_id1))
    (exit))
  (action_tile "accept" "(done_dialog)")
  (start_dialog)
  (unload_dialog dcl_id1)
  (princ))